"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _useSetting = _interopRequireDefault(require("./use-setting"));

var _hooks = require("./hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function useAuthentication(app) {
  const [isAuthenticated, setIsAuthenticated] = (0, _useSetting.default)(app, 'isAuthenticated', null);
  (0, _react.useDebugValue)(isAuthenticated);
  (0, _react.useEffect)(() => {
    async function checkStorage() {
      let value;

      try {
        await app.authenticate();
        value = true;
      } catch (err) {
        value = false;
      }

      setIsAuthenticated(value);
    }

    if (!app.get('hasAttemptedAuthentication')) {
      app.set('hasAttemptedAuthentication', true);
      checkStorage();
    }
  }, [app, setIsAuthenticated]);
  const setIsAuthenticatedTrue = (0, _react.useCallback)(() => {
    setIsAuthenticated(true);
  }, [setIsAuthenticated]);
  const setIsAuthenticatedFalse = (0, _react.useCallback)(() => {
    setIsAuthenticated(false);
  }, [setIsAuthenticated]);
  (0, _hooks.useEventEmitter)(app, 'authenticated', setIsAuthenticatedTrue);
  (0, _hooks.useEventEmitter)(app, 'logout', setIsAuthenticatedFalse);
  return isAuthenticated;
}

var _default = useAuthentication;
exports.default = _default;
//# sourceMappingURL=use-authentication.js.map