"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _hooks = require("./hooks");

function useSetting(app, name, initialState) {
  const [state, setState] = (0, _react.useState)(() => {
    const currentValue = app.get(name);
    return currentValue === undefined ? typeof initialState === 'function' ? initialState() : initialState : currentValue;
  });
  (0, _react.useDebugValue)(state);
  (0, _hooks.useEventEmitter)(app, `settingchange:${name}`, setState);
  return [state, (0, _react.useCallback)(value => {
    app.set(name, value);
    app.emit(`settingchange:${name}`, value);
  }, [app, name])];
}

var _default = useSetting;
exports.default = _default;
//# sourceMappingURL=use-setting.js.map